import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class Juego {
    private int numJugadores;

    private int turno;
    private int valorDado1;
    private int valorDado2;

    private ArrayList<TarjetaComunidad> tarjetasComunidad;

    private ArrayList<Dado> dados;

    private ArrayList<Jugador> jugadores;

    private Tablero tablero;

    private ArrayList<TarjetaSuerte> tarjetasSuerte;

    public Juego() {
        // creamos los dados
        dados = new ArrayList(); 
        dados.add(new Dado());
        dados.add(new Dado());
        
        // creamos el tablero
        tablero = new Tablero();
        
        // creamos los jugadores
        jugadores = new ArrayList();
        jugadores.add(new Jugador());
        jugadores.add(new Jugador());
        jugadores.get(0).setNombre("Luis");
        jugadores.get(1).setNombre("Pedro");
        
        jugadores.get(0).setPosicion(tablero.getCasillas().get(0));
        jugadores.get(1).setPosicion(tablero.getCasillas().get(0));
        
        setNumJugadores(2);
        setTurno(0);
        
    }

    public ArrayList<TarjetaComunidad> getTarjetasComunidad() {
        return tarjetasComunidad;
    }

    public void setTarjetasComunidad(ArrayList<TarjetaComunidad> val) {
        this.tarjetasComunidad = val;
    }

    public ArrayList<Dado> getDados() {
        return dados;
    }

    public void setDados(ArrayList<Dado> val) {
        this.dados = val;
    }

    public ArrayList<Jugador> getJugadores() {
        return jugadores;
    }

    public void setJugadores(ArrayList<Jugador> val) {
        this.jugadores = val;
    }

    public Tablero getTablero() {
        return tablero;
    }

    public void setTablero(Tablero val) {
        this.tablero = val;
    }

    public ArrayList<TarjetaSuerte> getTarjetasSuerte() {
        return tarjetasSuerte;
    }

    public void setTarjetasSuerte(ArrayList<TarjetaSuerte> val) {
        this.tarjetasSuerte = val;
    }

    public int getNumJugadores() {
        return numJugadores;
    }

    public void setNumJugadores(int val) {
        this.numJugadores = val;
    }
    
    public int getValorDado1() {
        return valorDado1;
    }

    public void setValorDado1(int val) {
        this.valorDado1 = val;
    }
    
    public int getValorDado2() {
        return valorDado2;
    }

    public void setValorDado2(int val) {
        this.valorDado2 = val;
    }

    public void cambiarTurno() {
        turno = (turno + 1) % numJugadores;
        System.out.println("CAMBIO DE TURNO: Va el jugador " + (turno+1));
    }

    public void tirarDados() {
        dados.get(0).lanzarDado();
        valorDado1 = dados.get(0).getValorCara();
        dados.get(1).lanzarDado();
        valorDado2 = dados.get(1).getValorCara();
    }

    public void comprarPropiedad() {
        System.out.println("  -> Muestra opcion de comprar la propiedad...");
    }

    public void mostrarOpcionesJugador() {
    }
    
    public void escogeCarta() {
        System.out.println("  -> Escoge carta de suerte/comunidad y la ejecuta...");
    }

    public int getTurno() {
        return turno;
    }

    public void setTurno(int val) {
        this.turno = val;
    }
    
    public void jugar() {
        
        /* NOTA: -------------------------------------------------------------------------
         *   El cdigo debe ser modificado para elimiar la gran cantidad de llamadas "get"
         *  de los mtodos. Se har con variables del tipo "jugadorActual", "nuevaCasilla"...
         * ------------------------------------------------------------------------------- */
    
        int numVecesDobles = 0;
        
        do {
            // tirar dados
            System.out.println("-------- ES EL TURNO DEL JUGADOR " + (turno+1) + "--------");
            
            System.out.println("Pulsa una tecla para lanzar los dados...");
            BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
            try {
                int ch = stdin.read();
            } catch (IOException ex) { }
            
            tirarDados();
            System.out.println("TIRA DADOS: saca un " + valorDado1 + " y un " + valorDado2);
            
            if (valorDado1 == valorDado2) {
                numVecesDobles++;
            }
            
            // si se ha sacado doble 3 veces....
            if (numVecesDobles == 3) {
                System.out.println("HAS SACADO 3 DOBLES SEGUIDOS!!! VAS A LA CARCEL!!!");
                jugadores.get(getTurno()).setPosicion(tablero.getCasillas().get(10));
                jugadores.get(getTurno()).setTurnosEnCarcel(3);
                jugadores.get(getTurno()).setDeVisita(false);
                cambiarTurno();
                return;
            }
            
            // obtiene posicion actual
            
            Casilla casillaActual = jugadores.get(getTurno()).getPosicion();
            int posicionActual = tablero.getCasillas().indexOf(casillaActual);
            
            System.out.println("Ests actualmente en la casilla " + (posicionActual+1));
            System.out.println("Vas a la casilla "  + ((posicionActual + valorDado1 + valorDado2)%40 +1) );
            
            jugadores.get(getTurno()).setPosicion(tablero.getCasillas().get((posicionActual + valorDado1 + valorDado2)%40));
            
            
            // actuar segun el tipo de casilla
            // en solar...
            if (jugadores.get(getTurno()).getPosicion().getClass().getName().equals("Solar")) {
                
                if (  ((Propiedad)(jugadores.get(getTurno()).getPosicion())).getPropietario() == null  )
                    comprarPropiedad();
                else
                {
                
                    int precio = ((Propiedad)(jugadores.get(getTurno()).getPosicion())).getPrecio();
                    jugadores.get(getTurno()).setCapital(-1*precio);
                    ((Propiedad)(jugadores.get(getTurno()).getPosicion())).getPropietario().setCapital(precio);
                    System.out.println("Caes en un solar con propietario. Le pagas a ste el alquiler.");
                }
                
            } else
            // en crcel...
            if (jugadores.get(getTurno()).getPosicion().getClass().getName().equals("Esquina") &&
                    jugadores.get(getTurno()).getPosicion().getIdCasilla() == 2) {
                
                jugadores.get(getTurno()).setDeVisita(true);
                System.out.println("Te encuentras de visita en la crcel... (ui!)");
                
            } else
            // en Ve a la crcel
            if (jugadores.get(getTurno()).getPosicion().getClass().getName().equals("Esquina") &&
                    jugadores.get(getTurno()).getPosicion().getIdCasilla() == 4) {
                
                System.out.println("Vaya suerte... VAS DIRECTO A LA CARCEL");
                jugadores.get(getTurno()).setPosicion(tablero.getCasillas().get(10));
                jugadores.get(getTurno()).setTurnosEnCarcel(3);
                jugadores.get(getTurno()).setDeVisita(false);
                cambiarTurno();
                return;
                
            } else
            // en suerte o comunidad
            if (jugadores.get(getTurno()).getPosicion().getClass().getName().equals("Suerte") ||
                jugadores.get(getTurno()).getPosicion().getClass().getName().equals("Comunidad")) {
                
                escogeCarta();
                
            } else
            {
            
                jugadores.get(getTurno()).setCapital(jugadores.get(getTurno()).getPosicion().getCantidad());
                System.out.println("Pagas la tasa indicada en la casilla...");
            
            }
            
        
        } while (valorDado1 == valorDado2);
        
        mostrarOpcionesJugador();
        
        cambiarTurno();
        
    
    }
    
    public static void main(String[] args) {
        Juego juego = new Juego();
        int i = 0;
        
        System.out.println(":::::::: PARTIDA DE PRUEBA, LIMITADA A 20 RONDAS ::::::::");
        
        do {
            juego.jugar();
            i++;
        } while (i < 20);
        
        System.out.println("Fin del juego");
    }
}
